﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Threading;
using BiDiBLib;

namespace BiDiBLibBeispiel
{

    public partial class FormMain : Form
    {
        BiDiBMsgHandler BiDiBMsg = new BiDiBMsgHandler();

        public FormMain()
        {
            InitializeComponent();
            BiDiBMsg.Init();
            BiDiBMsg.MainForm = this;
            BiDiBMsg.ProceedMSG = ProcessMSG;
            GlobalStatus.ResetSend = 0;
            GlobalStatus.log = true;
            string log;
            log = BiDiBMsg.InitSerialPortReg("Software\\BiDiBLib\\Beispiel");
            RTBLog.Text += log + "\n";
        }


        public void ProcessMSG()
        {
            int i, l,k;
            int len;
            byte[] tempb = new byte[64];
            byte[] adr = new byte[4];
            byte[] ifadr = new byte[4];
            ifadr[0] = 0;
            ifadr[1] = 0;
            ifadr[2] = 0;
            ifadr[3] = 0;

            if (GlobalStatus.log == true)
            {
                while (BiDiBMsg.InputHead != BiDiBMsg.InputTail)
                {
                    RTBLog.Text += "Input  : |" + BiDiBMsg.HexByteToBoxSub(BiDiBMsg.InputFiFo[BiDiBMsg.InputTail], 0, BiDiBMsg.InputFiFo[BiDiBMsg.InputTail++].Length - 1) + " |\n";
                    if (BiDiBMsg.InputTail > 511)
                        BiDiBMsg.InputTail = 0;
                }
            }
            while (BiDiBMsg.MsgTail != BiDiBMsg.MsgHead)
            {
                i = 1;
                len = BiDiBMsg.MsgFiFo[BiDiBMsg.MsgTail][0]-2;
                
                while (i < len)
                {
                    l = i;
                    GlobalMsg.MsgStart = i;
                    k = i++;
                    GlobalMsg.MsgLen = BiDiBMsg.MsgFiFo[BiDiBMsg.MsgTail][k];
                    GlobalMsg.MsgAdr1 = adr[0] = BiDiBMsg.MsgFiFo[BiDiBMsg.MsgTail][i++];
                    GlobalMsg.MsgAdr2 = adr[1] = 0;
                    GlobalMsg.MsgAdr3 = adr[2] = 0;
                    GlobalMsg.MsgAdr4 = adr[3] = 0;
                    if (GlobalMsg.MsgAdr1 > 0x00)
                    {
                        if (BiDiBMsg.MsgFiFo[BiDiBMsg.MsgTail][i] > 0x00)
                        {
                            GlobalMsg.MsgAdr2 = BiDiBMsg.MsgFiFo[BiDiBMsg.MsgTail][i++];
                            adr[1] = GlobalMsg.MsgAdr2;
                            if (BiDiBMsg.MsgFiFo[BiDiBMsg.MsgTail][i] > 0x00)
                            {
                                GlobalMsg.MsgAdr3 = BiDiBMsg.MsgFiFo[BiDiBMsg.MsgTail][i++];
                                adr[2] = GlobalMsg.MsgAdr3;
                                if (BiDiBMsg.MsgFiFo[BiDiBMsg.MsgTail][i] > 0x00)
                                {
                                    GlobalMsg.MsgAdr4 = BiDiBMsg.MsgFiFo[BiDiBMsg.MsgTail][i++];
                                    adr[3] = GlobalMsg.MsgAdr4;
                                }
                            }
                        }
                        i++;
                    }

                    adr[0] = GlobalMsg.MsgAdr1;
                    adr[1] = GlobalMsg.MsgAdr2;
                    adr[2] = GlobalMsg.MsgAdr3;
                    adr[3] = GlobalMsg.MsgAdr4;
                    i++;
                    string MsgStr = BiDiBMsg.GetMsgString(BiDiBMsg.MsgFiFo[BiDiBMsg.MsgTail][i]);

                    RTBLog.Text += "IN --- : " + MsgStr + " " + BiDiBMsg.HexByteToBoxSub(BiDiBMsg.MsgFiFo[BiDiBMsg.MsgTail], 1, GlobalMsg.MsgLen) + "\n";
                    
                    ExecMessages(adr, BiDiBMsg.MsgFiFo[BiDiBMsg.MsgTail][i++], BiDiBMsg.MsgFiFo[BiDiBMsg.MsgTail], i);

                    i = l + GlobalMsg.MsgLen + 1;
                }
                BiDiBMsg.MsgTail++;
                if (BiDiBMsg.MsgTail > 511)
                    BiDiBMsg.MsgTail = 0;
            }
            BiDiBMsg.ProceedMSGRunning = false;
            RTBLog.SelectionStart = RTBLog.TextLength;
            RTBLog.ScrollToCaret();
        }

        private void ExecMessages ( byte[] adr, byte msg, byte[] param, int pos )
        {
            if (msg == BiDiBMsg.GetMessageNum("MSG_SYS_MAGIC"))
            {
                CallMSG_SYS_MAGIC(adr, param, pos);
            }
        }

        private void CallMSG_SYS_MAGIC(byte[] adr, byte[] param, int pos)
        {
            if ((param[pos] == 0xFE) && (param[pos+1] == 0xAF))
            {
                if (GlobalStatus.ResetSend == 0)
                {
                    RTBLog.Text += BiDiBMsg.SendMsgNoParam(adr, "MSG_SYS_RESET", true, 0, false);
                    Thread.Sleep(1000);
                    RTBLog.Text += BiDiBMsg.SendMsgNoParam(adr, "MSG_SYS_GET_MAGIC", true, 1, false);
                    RTBLog.Text += BiDiBMsg.SendMsgOneParam(adr, "MSG_SYS_PING", 0xee, true, 2, false);
                    RTBLog.Text += BiDiBMsg.SendMsgNoParam(adr, "MSG_SYS_GET_UNIQUE_ID", true, 3, false);
                    RTBLog.Text += BiDiBMsg.SendMsgNoParam(adr, "MSG_SYS_ENABLE", true, 4, false);
                    GlobalStatus.ResetSend = 1;
                }
            }
        }
        private void buttonConnect_Click(object sender, EventArgs e)
        {
            byte[] adr = new byte[4] { 0, 0, 0, 0 };

            BiDiBMsg.BiDiBSerPort.BiDiBPort.Open();
            RTBLog.Text += BiDiBMsg.SendMsgNoParam(adr, "MSG_SYS_GET_MAGIC", true, 0, false);
            RTBLog.Text += BiDiBMsg.SendMsgNoParam(adr, "MSG_SYS_GET_MAGIC", true, 0, false);

        }
        private void buttonExit_Click(object sender, EventArgs e)
        {
            BiDiBMsg.BiDiBSerPort.BiDiBPort.Close();
            BiDiBMsg.BiDiBSerPort.BiDiBPort.Dispose();
            this.Close();
        }
    }
}
